#[doc = "Register `CHGDET_TRIM` reader"]
pub struct R(crate::R<CHGDET_TRIM_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<CHGDET_TRIM_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<CHGDET_TRIM_SPEC>> for R {
    fn from(reader: crate::R<CHGDET_TRIM_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `CHGDET_TRIM` writer"]
pub struct W(crate::W<CHGDET_TRIM_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<CHGDET_TRIM_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<CHGDET_TRIM_SPEC>> for W {
    fn from(writer: crate::W<CHGDET_TRIM_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `V325M_TRIM` reader - Trim bits for 325mV voltage reference. Used for charger detect comparator reference."]
pub struct V325M_TRIM_R(crate::FieldReader<u8, u8>);
impl V325M_TRIM_R {
    pub(crate) fn new(bits: u8) -> Self {
        V325M_TRIM_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for V325M_TRIM_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `V325M_TRIM` writer - Trim bits for 325mV voltage reference. Used for charger detect comparator reference."]
pub struct V325M_TRIM_W<'a> {
    w: &'a mut W,
}
impl<'a> V325M_TRIM_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x03) | (value as u32 & 0x03);
        self.w
    }
}
#[doc = "Field `V600M_TRIM` reader - Trim bits for 600mV voltage reference. Used for charger detect voltage driver."]
pub struct V600M_TRIM_R(crate::FieldReader<u8, u8>);
impl V600M_TRIM_R {
    pub(crate) fn new(bits: u8) -> Self {
        V600M_TRIM_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for V600M_TRIM_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `V600M_TRIM` writer - Trim bits for 600mV voltage reference. Used for charger detect voltage driver."]
pub struct V600M_TRIM_W<'a> {
    w: &'a mut W,
}
impl<'a> V600M_TRIM_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x07 << 4)) | ((value as u32 & 0x07) << 4);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:1 - Trim bits for 325mV voltage reference. Used for charger detect comparator reference."]
    #[inline(always)]
    pub fn v325m_trim(&self) -> V325M_TRIM_R {
        V325M_TRIM_R::new((self.bits & 0x03) as u8)
    }
    #[doc = "Bits 4:6 - Trim bits for 600mV voltage reference. Used for charger detect voltage driver."]
    #[inline(always)]
    pub fn v600m_trim(&self) -> V600M_TRIM_R {
        V600M_TRIM_R::new(((self.bits >> 4) & 0x07) as u8)
    }
}
impl W {
    #[doc = "Bits 0:1 - Trim bits for 325mV voltage reference. Used for charger detect comparator reference."]
    #[inline(always)]
    pub fn v325m_trim(&mut self) -> V325M_TRIM_W {
        V325M_TRIM_W { w: self }
    }
    #[doc = "Bits 4:6 - Trim bits for 600mV voltage reference. Used for charger detect voltage driver."]
    #[inline(always)]
    pub fn v600m_trim(&mut self) -> V600M_TRIM_W {
        V600M_TRIM_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Charger detect trim values\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [chgdet_trim](index.html) module"]
pub struct CHGDET_TRIM_SPEC;
impl crate::RegisterSpec for CHGDET_TRIM_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [chgdet_trim::R](R) reader structure"]
impl crate::Readable for CHGDET_TRIM_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [chgdet_trim::W](W) writer structure"]
impl crate::Writable for CHGDET_TRIM_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets CHGDET_TRIM to value 0"]
impl crate::Resettable for CHGDET_TRIM_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
